Attribute VB_Name = "Common"
Public NetDir As String
Public LogicDir As String
Public LocalAppDir As String

Dim commStr(10) As String, commInt(10) As Integer, commVar(10) As Variant

Public vrTagName As String, vrTagOpen As String, vrTagClose As String
Public csRptEDIWinTxt As String, csRptFile As String

Public TmpDir As String
Dim Initialized As Boolean

Public BolServices As String
Public LgxServices As String

Dim LseTools As String
Dim LseToolsWatchDir As String

Public Enum SaveToFileOptions
    Overwrite = 1
    Append = 2
    CreateUnique = 3
End Enum

Public Type AddressLines
    POBoxLineNo As Integer
    POBoxLines As Integer
    NonPOBoxLines As Integer
    NonEmptyLines As Integer
End Type

Public Function Initialize() As Boolean
    LogicDir = CS32.ShipDir & "Logic"
    If KiEmpty(Dir(LogicDir, vbDirectory)) Then
        MkDir LogicDir
    End If
    LogicDir = LogicDir & "\"
    NetDir = LogicDir
    
    LocalAppDir = "C:\Logic"
    If KiEmpty(Dir(LocalAppDir, vbDirectory)) Then
        LocalAppDir = ProjectDir
    Else
        LocalAppDir = LocalAppDir & "\"
    End If
    
    
    TmpDir = Common.LocalAppDir & "Temp"
    If Not fExist(TmpDir, vbDirectory) Then
        MkDir TmpDir
    End If
    TmpDir = TmpDir & "\"
    
    LseToolsWatchDir = TmpDir & "Watch"
    If Not fExist(LseToolsWatchDir, vbDirectory) Then
        MkDir LseToolsWatchDir
    End If
    
    commStr(0) = LseToolsWatchDir & "\Processed"
    If Not fExist(commStr(0), vbDirectory) Then
        MkDir commStr(0)
    End If
    
    commStr(0) = LseToolsWatchDir & "\Output"
    If Not fExist(commStr(0), vbDirectory) Then
        MkDir commStr(0)
    End If
    
    WinExecMod Common.NetDir & "CloseProcess.exe LseTools.exe"
    fErase TmpDir & "LseTools.exe"
    fCopy Common.NetDir & "LseTools.exe", TmpDir & "LseTools.exe"
    fCopy Common.NetDir & "LseCommFunc.dll", TmpDir & "LseCommFunc.dll"
    
    LseTools = TmpDir & "LseTools.exe /silent /watch=""" & LseToolsWatchDir & """"
    LseToolsWatchDir = LseToolsWatchDir & "\"
    
    Initialized = True
    Initialize = Initialized
End Function


Function GetCity(ByVal sCityState As String) As String
    GetCity = Alltrim(sCityState)
    
    If Len(GetCity) >= Len("X XX") Then
        If SubStr(GetCity, Len(GetCity) - 2, 1) = " " Then
            GetCity = Alltrim(Left(GetCity, Len(GetCity) - 2))
        End If
    End If
End Function

Function GetState(ByVal sCityState As String) As String
    GetState = ""
    sCityState = Trim(sCityState)
    If Len(sCityState) >= Len("X XX") Then
        If SubStr(sCityState, Len(sCityState) - 2, 1) = " " Then
            GetState = Alltrim(Right(sCityState, 2))
        End If
    End If
End Function

Function CheckAddressLines(ParamArray ShipToLines() As Variant) As Common.AddressLines
'Check address lines for existence of PO box, lines w/o PO box, etc.
    CheckAddressLines.NonEmptyLines = 0
    CheckAddressLines.NonPOBoxLines = 0
    CheckAddressLines.POBoxLines = 0
    CheckAddressLines.POBoxLineNo = 0
    
    Dim i As Integer
    Dim sLine As String
    For i = UBound(ShipToLines) To LBound(ShipToLines) Step -1
        sLine = UCase(Trim(ShipToLines(i)))
        sLine = StrTran(sLine, ".", "")
        sLine = StrTran(sLine, " ", "")
        
        If Not KiEmpty(sLine) Then
            CheckAddressLines.NonEmptyLines = CheckAddressLines.NonEmptyLines + 1
            
            If At("POBOX", sLine) = 1 Then
                CheckAddressLines.POBoxLines = CheckAddressLines.POBoxLines + 1
                CheckAddressLines.POBoxLineNo = i + 1
            Else
                CheckAddressLines.NonPOBoxLines = CheckAddressLines.NonPOBoxLines + 1
            End If
        End If
    Next
End Function


Function SaveTextToFile(ByVal sText As String, ByVal sFileName As String, Optional ByVal sExtension As String = "txt", Optional sPath As String = "", Optional ByVal iSaveOption As SaveToFileOptions) As String
    SaveTextToFile = ""
    
    If KiEmpty(sPath) Then
        sPath = ProjectDir
    End If
    If Right(sPath, 1) <> "\" Then
        sPath = sPath & "\"
    End If

    If Not KiEmpty(sExtension) And Left(sExtension, 1) <> "." Then
        sExtension = "." & sExtension
    End If
    
    If (iSaveOption = CreateUnique) Then
        commStr(0) = ""
        Do While fExist(sPath & sFileName & commStr(0) & sExtension)
            commStr(0) = Alltrim(Str(Val(commStr(0)) - 1))
        Loop
        sFileName = sFileName & commStr(0)
    End If
    
    commInt(0) = FreeFile
    kiDebug sPath & sFileName & sExtension & ": " & commInt(0), ProjectDir & "Debug.log", "SaveTextToFile()"
    Open sPath & sFileName & sExtension For Output As commInt(0)
    Print #commInt(0), sText
    Close #commInt(0)
    
    SaveTextToFile = sPath & sFileName & sExtension
End Function

Public Function DbfZap(ByVal sDbfFile, Optional ByVal sCondition As String = "1=1") As Boolean
    DbfDelete sDbfFile, sCondition, False, 0
    DbfZap = DbfCleanup(sDbfFile)
End Function

Public Sub Sql_InsertParam(ByRef sSqlQuery As String, ByVal iFieldId As Integer, ByVal sFieldData As String)
    sFieldData = StrTran(sFieldData, "'", "''")
    sSqlQuery = StrTran(sSqlQuery, "<%" & iFieldId & ">", sFieldData)
End Sub

Function VarReplace(ByVal TextData As String, ParamArray DataSourceInfo() As Variant) As String
    Dim vrReplaceText As String
    Dim vrResultText As String

    If KiEmpty(vrTagName) Then vrTagName = "var"
    If KiEmpty(vrTagOpen) Then vrTagOpen = "<"
    If KiEmpty(vrTagClose) Then vrTagClose = ">"
    If KiEmpty(vrMode) Then vrMode = "cs"
    If vrMode = "cs" Then
        If Lower(vrCsX) <> "xx" Then vrCsX = "x"
    End If
    
    vrResultText = TextData
    Do While Not KiEmpty(vrResultText)
        Dim vrReplaceNode As String
        Dim vrType As String, vrName As String, vrFormat As String, vrMask As String
        Dim vrStr(5) As String
        Dim vrInt(5) As Integer
        Dim vrKdvSrc As KiDataView
    
        vrInt(1) = At(vrTagOpen & vrTagName & " ", vrResultText)
        If vrInt(1) = 0 Then Exit Do
        
        vrStr(1) = SubStr(vrResultText, vrInt(1))
        vrInt(2) = At(vrTagClose, vrStr(1))
        vrStr(1) = Left(vrStr(1), vrInt(2))
        kiDebug vrStr(1), , "VarReplace()"
    
        vrReplaceNode = vrStr(1)
        If vrTagOpen <> "<" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagOpen, "<")
        End If
        If vrTagClose <> ">" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagClose, ">")
        End If
    
        If vrReplaceNode <> vrStr(1) Then
            vrResultText = StrTran(vrResultText, vrStr(1), vrReplaceNode)
        End If
        kiDebug vrReplaceNode, , "VarReplace()"
    
        vrReplaceText = ""
        vrStr(1) = ""
        vrStr(2) = ""
    

        vrType = Lower(Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@type"))
        vrName = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@name")
        vrFormat = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@format")
        vrMask = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@mask")
        kiDebug "@type=" & vrType & " @name=" & vrName & " @format=" & vrFormat & " @mask=" & vrMask, , "VarReplace()"
        
        Dim boolValidSource As Boolean
        Dim lIdx As Long
        boolValidSource = False
        For lIdx = LBound(DataSourceInfo) To UBound(DataSourceInfo) Step 2
            If DataSourceInfo(lIdx) = SubToken(vrType, 1, "-") Then
                Set vrKdvSrc = DataSourceInfo(lIdx + 1)
                boolValidSource = True
                Exit For
            End If
        Next
            
        If boolValidSource Then
            If SubToken(vrType, 2, "-") = "custom" Then
                vrReplaceText = Trim(VarReplace_Custom(vrName, vrKdvSrc))
            Else
                vrReplaceText = Trim(vrKdvSrc(vrName))
            End If
        End If
        kiDebug vrReplaceText, , "VarReplace()"
        
        If Len(vrFormat) > 0 Then
            kiDebug "Format: " + vrFormat, , "VarReplace()"
            vrStr(1) = Lower(Left(vrFormat, 1))
            If At(vrStr(1), "bdfim") > 0 Then
                vrFormat = SubStr(vrFormat, 2)
            Else
                vrStr(1) = "m"
            End If
            kiDebug "Format: Type=" + vrStr(1) + "; Def=" + vrFormat, , "VarReplace()"
    
            vrStr(2) = ""
            If vrStr(1) = "f" Then 'Fixed-point
                vrStr(2) = Str(Val(vrReplaceText), Val(SubToken(vrFormat, 1, ".")), Val(SubToken(vrFormat, 2, ".")))
                
            ElseIf vrStr(1) = "d" Then 'Date
                vrStr(2) = vrFormat
                
                vrStr(2) = StrTran(vrStr(2), "yyyy", Str(Year(CtoD(vrReplaceText))))
                vrStr(2) = StrTran(vrStr(2), "yy", Right(Str(Year(CtoD(vrReplaceText))), 2))
    
                vrStr(2) = StrTran(vrStr(2), "mmmm", Upper(Cmonth(CtoD(vrReplaceText))))
                vrStr(2) = StrTran(vrStr(2), "mmm", Left(Upper(Cmonth(CtoD(vrReplaceText))), 3))
                vrStr(2) = StrTran(vrStr(2), "mm", StrTran(Str(Month(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr(2) = StrTran(vrStr(2), "m", Str(Month(CtoD(vrReplaceText))))
    
                vrStr(2) = StrTran(vrStr(2), "dd", StrTran(Str(Day(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr(2) = StrTran(vrStr(2), "d", Str(Day(CtoD(vrReplaceText))))
    
            ElseIf vrStr(1) = "b" Then 'Boolean
                vrStr3 = SubToken(vrFormat, 3, "|")
                vrStr4 = ""
                If At("!", vrStr3) = 1 Then
                    vrStr4 = "!"
                    vrStr3 = SubStr(vrStr3, 2)
                End If
                    
                If (vrReplaceText = vrStr3 And vrStr4 <> "!") Or (vrReplaceText <> vrStr3 And vrStr4 = "!") Then
                    vrStr(2) = SubToken(vrFormat, 1, "|")
                Else
                    vrStr(2) = SubToken(vrFormat, 2, "|")
                End If
            ElseIf vrStr(1) = "i" Then 'Integer
                vrNum1 = Val(vrReplaceText)
                If Right(vrFormat, 1) = "u" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrNum1 = Roundup(vrNum1, 1)
                ElseIf Right(vrFormat, 1) = "d" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrNum1 = Int(vrNum1)
                Else
                    vrNum1 = Round(vrNum1, 1)
                End If
                vrStr(2) = Str(vrNum1, Val(vrFormat))
                If (Val(vrFormat) > 0 And Left(vrFormat, 1) = "0") Then
                    vrStr(2) = StrTran(vrStr(2), " ", "0")
                End If
            End If
            vrReplaceText = vrStr(2)
            kiDebug vrStr(2), , "VarReplace()"
        End If
        
        kiDebug "VarReplace: " + vrReplaceNode + " => " + vrReplaceText, , "VarReplace()"
        
        vrResultText = StrTran(vrResultText, vrReplaceNode, vrReplaceText)
    Loop
    
    vrMode = ""
    vrCsX = ""
    vrTagName = ""
    vrTagOpen = ""
    vrTagClose = ""
    
    VarReplace = vrResultText
End Function


Function VarReplaceOLD(ByVal vrTextData As String, ByVal vrSource1 As KiDataView, Optional ByVal vrSource2 As KiDataView) As String
    Dim vrReplaceText As String
    Dim vrResultText As String

    If KiEmpty(vrTagName) Then vrTagName = "var"
    If KiEmpty(vrTagOpen) Then vrTagOpen = "<"
    If KiEmpty(vrTagClose) Then vrTagClose = ">"
    If KiEmpty(vrMode) Then vrMode = "cs"
    If vrMode = "cs" Then
        If Lower(vrCsX) <> "xx" Then vrCsX = "x"
    End If
    
    vrResultText = vrTextData
    Do While Not KiEmpty(vrResultText)
        Dim vrReplaceNode As String
        Dim vrType As String, vrName As String, vrFormat As String, vrMask As String
        Dim vrStr1 As String, vrStr2 As String, vrStr3 As String, vrStr4 As String
        Dim vrInt1 As Integer, vrInt2 As Integer, vrInt3 As Integer, vrInt4 As Integer
    
        vrInt1 = At(vrTagOpen & vrTagName & " ", vrResultText)
        If vrInt1 = 0 Then Exit Do
        
        vrStr1 = SubStr(vrResultText, vrInt1)
        vrInt2 = At(vrTagClose, vrStr1)
        vrStr1 = Left(vrStr1, vrInt2)
        kiDebug vrStr1, , "VarReplace()"
    
        vrReplaceNode = vrStr1
        If vrTagOpen <> "<" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagOpen, "<")
        End If
        If vrTagClose <> ">" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagClose, ">")
        End If
    
        If vrReplaceNode <> vrStr1 Then
            vrResultText = StrTran(vrResultText, vrStr1, vrReplaceNode)
        End If
        kiDebug vrReplaceNode, , "VarReplace()"
    
        vrReplaceText = ""
        vrStr1 = ""
        vrStr2 = ""
    

        vrType = Lower(Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@type"))
        vrName = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@name")
        vrFormat = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@format")
        vrMask = Xml.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@mask")
        kiDebug "@type=" & vrType & " @name=" & vrName & " @format=" & vrFormat & " @mask=" & vrMask, , "VarReplace()"
        If vrType = "csfield" Or vrType = "dbfield" Then
            vrReplaceText = Alltrim(vrSource1(vrName))
        ElseIf vrType = "custom" Then
            vrReplaceText = VarReplace_Custom(vrName, vrSource1)
        Else
        
        End If
        kiDebug vrReplaceText, , "VarReplace()"
        
        If Len(vrFormat) > 0 Then
            kiDebug "Format: " + vrFormat, , "VarReplace()"
            vrStr1 = Lower(Left(vrFormat, 1))
            If At(vrStr1, "bdfim") > 0 Then
                vrFormat = SubStr(vrFormat, 2)
            Else
                vrStr1 = "m"
            End If
            kiDebug "Format: Type=" + vrStr1 + "; Def=" + vrFormat, , "VarReplace()"
    
            vrStr2 = ""
            If vrStr1 = "f" Then 'Fixed-point
                vrStr2 = Str(Val(vrReplaceText), Val(SubToken(vrFormat, 1, ".")), Val(SubToken(vrFormat, 2, ".")))
                
            ElseIf vrStr1 = "d" Then 'Date
                vrStr2 = vrFormat
                
                vrStr2 = StrTran(vrStr2, "yyyy", Str(Year(CtoD(vrReplaceText))))
                vrStr2 = StrTran(vrStr2, "yy", Right(Str(Year(CtoD(vrReplaceText))), 2))
    
                vrStr2 = StrTran(vrStr2, "mmmm", Upper(Cmonth(CtoD(vrReplaceText))))
                vrStr2 = StrTran(vrStr2, "mmm", Left(Upper(Cmonth(CtoD(vrReplaceText))), 3))
                vrStr2 = StrTran(vrStr2, "mm", StrTran(Str(Month(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr2 = StrTran(vrStr2, "m", Str(Month(CtoD(vrReplaceText))))
    
                vrStr2 = StrTran(vrStr2, "dd", StrTran(Str(Day(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr2 = StrTran(vrStr2, "d", Str(Day(CtoD(vrReplaceText))))
    
            ElseIf vrStr1 = "b" Then 'Boolean
                vrStr3 = SubToken(vrFormat, 3, "|")
                vrStr4 = ""
                If At("!", vrStr3) = 1 Then
                    vrStr4 = "!"
                    vrStr3 = SubStr(vrStr3, 2)
                End If
                    
                If (vrReplaceText = vrStr3 And vrStr4 <> "!") Or (vrReplaceText <> vrStr3 And vrStr4 = "!") Then
                    vrStr2 = SubToken(vrFormat, 1, "|")
                Else
                    vrStr2 = SubToken(vrFormat, 2, "|")
                End If
            ElseIf vrStr1 = "i" Then 'Integer
                vrNum1 = Val(vrReplaceText)
                If Right(vrFormat, 1) = "u" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrNum1 = Roundup(vrNum1, 1)
                ElseIf Right(vrFormat, 1) = "d" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrNum1 = Int(vrNum1)
                Else
                    vrNum1 = Round(vrNum1, 1)
                End If
                vrStr2 = Str(vrNum1, Val(vrFormat))
                If (Val(vrFormat) > 0 And Left(vrFormat, 1) = "0") Then
                    vrStr2 = StrTran(vrStr2, " ", "0")
                End If
            End If
            vrReplaceText = vrStr2
            kiDebug vrStr2, , "VarReplace()"
        End If
        
        kiDebug "VarReplace: " + vrReplaceNode + " => " + vrReplaceText, , "VarReplace()"
        
        vrResultText = StrTran(vrResultText, vrReplaceNode, vrReplaceText)
    Loop
    
    vrMode = ""
    vrCsX = ""
    vrTagName = ""
    vrTagOpen = ""
    vrTagClose = ""
    
    VarReplaceOLD = vrResultText
End Function

Function VarReplace_Custom(ByVal vrName As String, ByVal KdvSource As KiDataView) As String
    Dim tmpStr1 As String, tmpStr2 As String, tmpStr3 As String, tmpstr4 As String
    Dim tmpStr(5) As String, tmpInt(5) As Integer
    
    Dim vrReturn As String
    
    vrReturn = ""
    
    Select Case SubToken(vrName, 1, ",")
        Case "TRACK_LINK"
            tmpStr1 = Alltrim(KdvSource("INTCODE"))
            
            tmpStr2 = "XXXXX"
            If Left(tmpStr1, 1) = "U" Then
                tmpStr2 = "UPS"
            ElseIf Left(tmpStr1, 1) = "F" Or Left(tmpStr1, 1) = "R" Then
                tmpStr2 = "FedEx"
            ElseIf Left(tmpStr1, 1) = "P" Then
                tmpStr2 = "USPS"
            End If
            
            vrReturn = IniRead(emlIni, "Tracking URLs", tmpStr2, "<include type=""CSFIELD"" name=""TRACK_NO"" />")
        Case "SHIPTO"
            tmpStr1 = SubToken(vrName, 2, ",")
            If At("LAST", tmpStr1) = 1 Then
            'Get populated shipto lines, from bottom-up.
            '"LAST" = last populated line, "LAST-1" = next to last populated line, etc.
            
                'Get value from LAST-#
                tmpInt(1) = Val(SubToken(tmpStr1, 2, "-"))
                                
                'Start with SHIPTO7
                tmpInt(2) = 7
                Do While tmpInt(2) > 0 And tmpInt(1) >= 0
                    'Check next SHIPTO
                    tmpStr(2) = Trim(KdvSource("SHIPTO" & tmpInt(2)))
                    If Not KiEmpty(tmpStr(2)) Then
                        'If populated, decrement LINE-# value.
                        tmpInt(1) = tmpInt(1) - 1
                    End If
                    tmpInt(2) = tmpInt(2) - 1
                Loop
                If tmpInt(1) >= 0 Then
                    tmpStr(2) = ""
                End If
                
                vrReturn = tmpStr(2)
            End If
    End Select
    
    VarReplace_Custom = vrReturn
End Function

Sub LogWrite(ByVal sLogText As String, Optional ByVal iLogLevel As Integer = 999, Optional ByVal sSource As String = "")
    kiDebug sLogText, ProjectDir & "debug.log", sSource
End Sub

Sub GetReportDate()
    'Get selected file for Reports-EDI from window title.
    emlGetReportDateRunCount = emlGetReportDateRunCount + 1
    
    If InStr(GetWinText, "Reports-EDI ") And GetWinText <> csRptEDIWinTxt Then
        csRptEDIWinTxt = GetWinText
        csRptFile = Lower(Alltrim(SubStr(csRptEDIWinTxt, 14)))
        If csRptFile = "ship file" Then
            csRptFile = CS32.ShipDir + "cs_ship.fil"
        ElseIf csRptFile = "hold file" Then
            csRptFile = CS32.ShipDir + "cs_hold.fil"
        ElseIf At("merged", csRptFile) > 0 Then
            csRptFile = "merged files"
        Else
            csRptFile = IniRead(CS32.ShipDir & "cs_main.ini", "DirectorySetup", "Archive", CS32.ShipDir & "Archive") & "\" & Left(csRptFile, 3) + StrTran(SubStr(csRptFile, 5, 2), " ", "0") + "_" + Right(csRptFile, 2) + ".cs"
        End If
        
    '    If lsxLogLvl > 1
    '        lsxLogTxt = "Reports-EDI file selected: " + lsxCsRptFile
    '        LSX_LogWrite()
    '    End If
        MsgBox csRptEDIWinTxt & vbLf & csRptFile, vbOKOnly, "GetReportDate() [" & emlGetReportDateRunCount & "]"
    End If
End Sub


Function ReadEntireFile(ByVal sFileName)
    Dim iFileNum As Integer
    Dim sFileText As String
    sFileText = ""
    
    If fExist(sFileName) Then
        iFileNum = FreeFile
        Open sFileName For Input As #iFileNum
        sFileText = Input$(LOF(iFileNum), iFileNum)
        Close #iFileNum
    End If
    
    ReadEntireFile = sFileText
End Function

Public Function URLEncode(StringVal As String, Optional SpaceAsPlus As Boolean = False) As String
    URLEncode = StringVal
    
    Dim Result() As String
    Dim StringLen As Long: StringLen = Len(StringVal)
    
    If StringLen > 0 Then
        ReDim Result(StringLen) As String
        Dim i As Long, CharCode As Integer
        Dim Char As String, Space As String
        
        If SpaceAsPlus Then Space = "+" Else Space = "%20"
        For i = 1 To StringLen
            Char = Mid$(StringVal, i, 1)
            CharCode = Asc(Char)
            Select Case CharCode
                Case 97 To 122, 65 To 90, 48 To 57, 45, 46, 95, 126
                    Result(i) = Char
                Case 32
                    Result(i) = Space
                Case 0 To 15
                    Result(i) = "%0" & Hex(CharCode)
                Case Else
                    Result(i) = "%" & Hex(CharCode)
            End Select
        Next i
        URLEncode = Join(Result, "")
    End If
End Function

Public Function GetCommonSetting(ByRef SettingValue, ByVal SettingName) As Boolean
    Dim sReturn As String
    
    sReturn = IniRead(NetDir & "common.ini", "Settings:" & ComputerName, SettingName, IniRead(NetDir & "common.ini", "Global Settings", SettingName, ""))
    If sReturn = "" Then
        GetCommonSetting = False
    Else
        SettingValue = sReturn
        GetCommonSetting = True
    End If
End Function

Public Function TimerElapsed(ByVal TimerStart As Single) As Single
    TimerElapsed = Timer - TimerStart
End Function


Public Function Base64_Decode(ByVal Base64Filename As String, ByVal DecodedFileName As String, Optional ByVal DeleteOriginal As Boolean = True, Optional ByVal InjectZPL As String = "")
    If Not Initialized Then
        Initialize
    End If
    
    Dim sXmlRq As String
    Dim sDelete As String
    
    sDelete = "false"
    If DeleteOriginal Then
        sDelete = "true"
    End If
    
    If Not KiEmpty(InjectZPL) Then
        InjectZPL = Xml.WriteTag("injectzpl", InjectZPL)
    End If
        
    sXmlRq = "<decode>" & _
        XmlWriteTag("base64file", Base64Filename) & _
        XmlWriteTag("decodedfile", DecodedFileName) & _
        XmlWriteTag("deleteoriginal", sDelete) & _
        InjectZPL & _
        "</decode>"
            
    fErase DecodedFileName
    fErase LseToolsWatchDir & "Output\DecodeB64.xml"
        
    Common.SaveTextToFile sXmlRq, "DecodeB64", "xml", LseToolsWatchDir, Overwrite
        
    WinExec LseTools

    Dim sngTimeStart As Single
    sngTimeStart = Timer
    Do While Common.TimerElapsed(sngTimeStart) < 10
        If fExist(LseToolsWatchDir & "Output\DecodeB64.xml") Then
            Delay 0.1
            Exit Do
        End If
        Delay 0.1
    Loop
End Function

Public Function SendFileToPrinter(ByVal PrinterName As String, ByVal PrintFile As String, Optional ByVal PrintCopies As Integer = 1) As Boolean
    If Not Initialized Then
        Initialize
    End If
    
    commStr(0) = "<sendtoprinter>" & _
        XmlWriteTag("printername", PrinterName) & _
        XmlWriteTag("printfile", PrintFile) & _
        XmlWriteTag("printcopies", PrintCopies) & _
        "</sendtoprinter>"
                        
    fErase LseToolsWatchDir & "Output\Print.xml"
    Common.SaveTextToFile commStr(0), "Print", "xml", LseToolsWatchDir, Overwrite
                    
    WinExec LseTools

    Dim sngTimeStart As Single
    sngTimeStart = Timer
    Do While Common.TimerElapsed(sngTimeStart) < 10
        If fExist(LseToolsWatchDir & "Output\Print.xml") Then
            Delay 0.1
            Exit Do
        End If
        Delay 0.1
    Loop
End Function

Public Function PrintGenericShippingLabel(Optional ByVal Copies = 1) As Boolean
    Dim sPrinterName As String
    
    If Not Common.GetCommonSetting(sPrinterName, "LabelPrinter") Then
        MsgBox "Label printer not defined!", vbCritical
        PrintGenericShippingLabel = False
    Else
        Dim sLabelData As String
        Dim sLabelFile As String
        
        sLabelData = CreateGenericShippingLabel()
        
        sLabelFile = Common.SaveTextToFile(sLabelData, "GenericLabel", "txt", TmpDir, SaveToFileOptions.Overwrite)
        
        Common.SendFileToPrinter sPrinterName, sLabelFile, Copies
    End If
End Function

Public Function CreateGenericShippingLabel() As String
    Dim sLabelTemplate As String
    
    sLabelTemplate = "" & _
        "^XA" & vbLf & _
        "^LH000,000^PRD" & vbLf & _
        "^FO020,0020^A0N,40,40^FDFROM:^FS" & vbLf & _
        "^FO050,0060^ADN,36,10^FD<var type=""cs_acct"" name=""FROM1"" />^FS" & vbLf & _
        "^FO050,0100^ADN,36,10^FD<var type=""cs_acct"" name=""FROM2"" />^FS" & vbLf & _
        "^FO050,0140^ADN,36,10^FD<var type=""cs_acct"" name=""FROM3"" />^FS" & vbLf & _
        "^FO050,0180^ADN,36,10^FD<var type=""cs_acct"" name=""FROM4"" />^FS" & vbLf & _
        "^FO540,0020^A0N,40,40^FD<var type=""cs_ship"" name=""ORD_CNT"" /> OF <var type=""cs_ship"" name=""EXP_CNT"" />^FS" & vbLf & _
        "^FO540,0060^A0N,40,40^FD<var type=""cs_ship"" name=""ACT_WGT"" /> LBS^FS" & vbLf

    sLabelTemplate = sLabelTemplate & _
        "^FO020,232^A0N,40,40^FDSHIP TO:^FS" & vbLf & _
        "^FO050,272^ADN,18,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-6"" />^FS" & vbLf & _
        "^FO050,296^ADN,18,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-5"" />^FS" & vbLf & _
        "^FO050,320^ADN,36,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-4"" />^FS" & vbLf & _
        "^FO050,360^ADN,36,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-3"" />^FS" & vbLf & _
        "^FO050,400^ADN,36,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-2"" />^FS" & vbLf & _
        "^FO050,440^ADN,36,10^FD<var type=""cs_ship-custom"" name=""SHIPTO,LAST-1"" />^FS" & vbLf & _
        "^FO050,480^A0N,60,38^FD<var type=""cs_ship"" name=""SHIPTO7"" /> <var type=""cs_ship"" name=""ZIP"" />^FS" & vbLf & _
        "^FO050,540^A0N,60,38^FD<var type=""cs_ship"" name=""COUNTRY"" />^FS" & vbLf & _
        "^FO000,0601^GB820,0,13^FS" & vbLf & _
        "^FO050,0633^ADN,72,20^FD<var type=""cs_ship"" name=""CARNAME"" />^FS" & vbLf & _
        "^FO050,0707^ADN,36,20^FDTRACKING NUMBER^FS" & vbLf & _
        "^FO000,0753^GB820,0,3^FS" & vbLf & _
        "^FO060,0774^BY4,2.0^BCN,205,N,N^FD<var type=""cs_ship"" name=""TRACK_NO"" />^FS" & vbLf & _
        "^FO100,0998^ADN,36,20^FD<var type=""cs_ship"" name=""TRACK_NO"" />^FS" & vbLf & _
        "^FO000,1046^GB820,0,13^FS" & vbLf & _
        "^FO020,1070^ADN,28,12^FD<var type=""custom"" name=""label_ref1"" />^FS" & vbLf & _
        "^FO020,1103^ADN,28,12^FD<var type=""custom"" name=""label_ref2"" />^FS" & vbLf & _
        "^FO020,1136^ADN,28,12^FD<var type=""custom"" name=""label_ref3"" />^FS" & vbLf & _
        "^FO020,1169^ADN,28,12^FD<var type=""custom"" name=""label_ref4"" />^FS" & vbLf & _
        "^XZ" & vbLf

    Dim kdvCsShip As KiDataView
    Set kdvCsShip = DbfSelect(CS32.ShipDir & "CS_SHIP.FIL", "STATUS='    ' AND PKGID='" & CS32.GetVar("xxPKGID") & "' AND ORD_CNT=" & CS32.GetVar("xxORD_CNT"))
    
    CreateGenericShippingLabel = Common.VarReplace(sLabelTemplate, "cs_ship", kdvCsShip, "cs_acct", DbfSelect(CS32.ShipDir & "CS_ACCT.FIL", "RecNo()=" & CS32.GetVar("xxACCOUNT")))
    'CreateGenericShippingLabel = Common.VarReplace(sLabelTemplate, "cs_ship", CS32.XXVars, "cs_acct", DbfSelect(CS32.ShipDir & "CS_ACCT.FIL", "RecNo()=" & CS32.GetVar("xxACCOUNT")))
End Function


Public Function PrintPdf(ByVal PdfFile As String, Optional ByVal Copies As Integer = 1) As Boolean
    Dim sPdfReader As String
    Dim sPdfArgs As String
    
    PrintPdf = False
    
    If Not fExist(PdfFile) Then
        MsgBox "Pdf file not found: " & PdfFile, vbCritical
        Exit Function
    End If
    If Not Common.GetCommonSetting(sPdfReader, "PdfReader") Then
        MsgBox "PDF Reader not configured!", vbCritical
        Exit Function
    End If
    Common.GetCommonSetting sPdfArgs, "PdfPrintParameters"
            
    If (WinExec(sPdfReader & " " & sPdfArgs & " """ & PdfFile & """") <> 0) Then
        PrintPdf = True
    End If
    'Do While PrintPdf And Copies > 1
    '    WinExec sPdfReader & " " & sPdfArgs & " """ & PdfFile & """"
    '    Copies = Copies - 1
    'Loop
End Function

Public Function GetLength(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    GetLength = Roundup(Max(dblDim1, Max(dblDim2, dblDim3)), 1)
End Function
Public Function GetGirth(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    If (dblDim1 > dblDim2) Then
        dblDim1 = dblDim2
        dblDim2 = dblDim3
        dblDim3 = 99999
    End If
    If (dblDim2 > dblDim3) Then
        dblDim2 = dblDim3
        dblDim3 = 99999
    End If
    
    GetGirth = (Roundup(dblDim1, 1) + Roundup(dblDim2, 1)) * 2
End Function
Public Function GetLengthPlusGirth(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    Dim dblLength As Double
    Dim dblGirth As Double
    
    GetLengthPlusGirth = GetLength(dblDim1, dblDim2, dblDim3)
    GetLengthPlusGirth = GetLengthPlusGirth + GetGirth(dblDim1, dblDim2, dblDim3)
End Function

Public Function IsLTL(ByVal sIntcode As String) As Boolean
    IsLTL = False
    
    IsLTL = IsLTL Or At(";" & sIntcode & ";", Common.BolServices) > 0
    IsLTL = IsLTL Or At(";" & Left(sIntcode, 2) & ";", Common.BolServices) > 0
    IsLTL = IsLTL Or At(";" & Left(sIntcode, 1) & ";", Common.BolServices) > 0
End Function


Public Sub FileCleanup()
    If fExist(Common.LogicDir & "FileCleanup.vbs") Then
        fCopy Common.LogicDir & "FileCleanup.vbs", Common.TmpDir & "FileCleanup.vbs"
        Shell "wscript " & Common.TmpDir & "FileCleanup.vbs", vbNormalFocus
    End If
End Sub
