Attribute VB_Name = "FedExFreight"
Dim fxfDir As String
Dim fxfInitialized As Boolean

Dim fxfFsmsIP As String, fxfFsmsPort As Integer

Dim fxfStr(10) As String

Public Function FXF_Initialize() As Boolean
    FXF_Initialize = fxfInitialized
    If fxfInitialized Then
        Exit Function
    End If
    
    Dim csFdxDir As String
    csFdxDir = IniRead(CS32.ShipDir & "CS_MAIN.INI", "DirectorySetup", "FedEx", CS32.ShipDir & "FDX") & "\"
    
    
    fxfDir = NetDir & "FDXF"
    If Not fExist(fxfDir, vbDirectory) Then
        MkDir fxfDir
    End If
    fxfDir = fxfDir & "\"
    
    If Not fExist(fxfDir & "Labels", vbDirectory) Then
        MkDir fxfDir & "Labels"
    End If
    If Not fExist(fxfDir & "BOL", vbDirectory) Then
        MkDir fxfDir & "BOL"
    End If
    
    fxfFsmsIP = IniRead(fxfDir & "FDXF.ini", "FSMS", "IP", IniRead(csFdxDir & "FDX.ini", "SERVER", "FdxServerAddress", ""))
    If KiEmpty(fxfFsmsIP) Then
        MsgBox "FSMS connection not configured!", vbCritical
        Exit Function
    End If
    
    fxfFsmsPort = Int(IniRead(fxfDir & "FDXF.ini", "FSMS", "Port", IniRead(csFdxDir & "FDX.ini", "SERVER", "FdxServerPort", "2000")))
    If fxfFsmsPort <= 0 Then
        MsgBox "FSMS connection not configured!", vbCritical
        Exit Function
    End If
    
    fxfStr(0) = IniRead(fxfDir & "FDXF.ini", "Services")
    If KiEmpty(fxfStr(0)) Then
        IniWrite fxfDir & "FDXF.ini", "Services", "ZFP", "112"
        IniWrite fxfDir & "FDXF.ini", "Services", "ZFE", "113"
    End If
    
    fxfInitialized = True
    FXF_Initialize = fxfInitialized
End Function

Public Function FXF_GetService(ByVal sIntcode As String) As String
    FXF_GetService = IniRead(fxfDir & "FDXF.ini", "Services", sIntcode, "")
End Function

Public Sub FXF_Process()
    fxfInitialized = FXF_Initialize()
    
    Dim fxfService As String
    fxfService = ""
    
    fxfService = FXF_GetService(Trim(CS32.GetVar("xINTCODE")))
    If KiEmpty(fxfService) Then
        Exit Sub
    End If
    
    If Not fxfInitialized Then
        CS32.SetError "FedEx Freight not configured!"
        Exit Sub
    End If

    BillOfLading.Prompt
    
    Dim kdvBlData As KiDataView
    Set kdvBlData = DbfSelect(ProjectDir & "BL_DATA.DBF", , , 0)
    
    Dim csAcctNo As String
    csAcctNo = Alltrim(CS32.GetVar("xACCOUNT"))
    
    Dim BOLReportsPath As String
    Dim BOLFileName As String
    Dim BOLTracking As String
    Dim BOLLabelBuffer As String
    Dim BOLWaitTime As Integer
    Dim BOLFound As Boolean
    
    Dim AdobePath As String
    
On Error GoTo ERRORHANDLER
    FSMS.Server = fxfFsmsIP
    FSMS.Port = fxfFsmsPort
    FSMS.ShowStatus = True
    FSMS.Start
    If FSMS.Started Then
    
        FSMS.ShowStatus = True
                   
        FSMS.BeginTrans 60
        
        '1-Customer Transaction Identifier
        FSMS.SetFieldValue 1, Alltrim(CS32.GetVar("xpkgid"))
        
        '11-Recpient Company Name
        FSMS.SetFieldValue 11, Alltrim(CS32.GetVar("xshipto1"))
        
        '12-Recpient Contact Name
        FSMS.SetFieldValue 12, Alltrim(CS32.GetVar("xshipto3"))
        
        '13-Recpient Address Line 1
        FSMS.SetFieldValue 13, Alltrim(CS32.GetVar("xshipto4"))
        
        '14-Recpient Address Line 2
        FSMS.SetFieldValue 14, Alltrim(CS32.GetVar("xshipto5"))
              
        '15-Recpient City
        FSMS.SetFieldValue 15, Common.GetCity(CS32.GetVar("xshipto7"))
        
        '16-Recpient State
        FSMS.SetFieldValue 16, Common.GetState(CS32.GetVar("xshipto7"))
        
        '17-Recpient Postal Code
        FSMS.SetFieldValue 17, Left(Alltrim(CS32.GetVar("xzip")), 5)
        
        '18-Recpient Phone Number
        FSMS.SetFieldValue 18, Alltrim(CS32.GetVar("xphone"))
        
        '32-Sender Contact Name
        FSMS.SetFieldValue 32, IniRead(fxfDir & "FDXF.ini", "Account" & csAcctNo, "SenderContact", "Shipping Department")
        
        '50-Recipent Country
        If Alltrim(CS32.GetVar("xcountry")) = "CANADA" Then
            FSMS.SetFieldValue 50, "CA"
        Else
            FSMS.SetFieldValue 50, "US"
        End If
        
        '69-Carriage Value
        If Val(CS32.GetVar("xunit")) <= 0 Then
            CS32.SetVar "xunit", "1"
        End If
        FSMS.SetFieldValue 69, CDec(CS32.GetVar("xunit"))
         
        '76-Number of Pieces
        FSMS.SetFieldValue 76, CInt(kdvBlData("pkg_qty"))
        
        '79-Description Of Contents
        FSMS.SetFieldValue 79, Trim(kdvBlData("itemdesc"))
        
        '117-Sender Country Code
        FSMS.SetFieldValue 117, "US"
        
        '119
        
        '183-Sender Phone Number
        FSMS.SetFieldValue 183, Alltrim(CS32.GetVar("xFROM4"))
        
        '187-Label Format
        FSMS.SetFieldValue 187, "288"
'TODO lookup in profile to get label printer
             '199  Eltron LP2348/LP2443 4" x 6" doc-tab
             '299  Eltron LP2348/LP2443 4" x6" (non doc-tab)
             '399  Eltron/Zebra EPL 4" x 8"
             '499  Eltron/Zebra EPL 4" x 9"
             '188  Zebra* DA402 4" x 6" doc-tab
             '288  Zebra* DA402 4" x 6" (non doc-tab)
             '388  Zebra 4" x 8"
             '488  Zebra 4" x 9"
        
        '498-Meter Number

        FSMS.SetFieldValue 498, IniRead(fxfDir & "FDXF.ini", "Account" & csAcctNo, "Meter", Alltrim(CS32.GetVar("xFDXPWS_NO")))
        
        '537-Thermal Printer ID
        FSMS.SetFieldValue 537, "C:\fedex\fedex_labelbuffer\"
        
        '1201-Sender Email Address
        FSMS.SetFieldValue 1201, ""
        
        '1202-Recipent Email Address
        FSMS.SetFieldValue 1202, Alltrim(CS32.GetVar("xCONSEMAIL"))
        
        '1203-Personal Message
        FSMS.SetFieldValue 1203, ""
        
        '1206-Ship Alert Flag
        FSMS.SetFieldValue 1206, "N"
        
        '1271-SLAC
        FSMS.SetFieldValue 1271, kdvBlData("hnd_qty")
             
        '1274-Service Type
'TODO; lookup based on carrier/intcode code
        FSMS.SetFieldValue 1274, fxfService
        '112 = Priority
        '113 = Economy
        
        '1282-thermal_label_print_flag
'TODO; check this field
        FSMS.SetFieldValue 1282, "188"
        
        '1300-Purchase_Order_number
        FSMS.SetFieldValue 1300, Trim(CS32.GetVar("xpo_no"))
        
        '1551-Delivery Notify Flags
        FSMS.SetFieldValue 1551, "N"
        
        '3021-Special Instructions
        FSMS.SetFieldValue 3021, Trim(kdvBlData("spec_inst"))
        
        '3056-Package Purchase Order Number (could be multiple)
        FSMS.SetFieldValue 3056, Alltrim(CS32.GetVar("xpo_no"))
        
        '4683-Bill of Lading Number
        'FSMS.SetFieldValue 4683, kdvBlData("bl_number")
        
        '6101-Shipment Volume
        
        
        '6106-NMFC Item #  (could be multiple)
        FSMS.SetFieldValue 6106, kdvBlData("nmfc")
        
        '6107-Shipment Terms
        FSMS.SetFieldValue 6107, Alltrim(CS32.GetVar("xpay_flag"))
        
        '6110-LTL Special Services
        XC1 = Trim(kdvBlData("ss_flags"))
        If KiEmpty(XC1) Then
            XC1 = IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "SpecialServiceFlags", Replicate("N", 19))
        End If
        FSMS.SetFieldValue 6110, XC1
        
        '6116-Freight Payor Role/Type
        FSMS.SetFieldValue 6116, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "FreightPayorType", "1")
        
        '6128-FXF Billing Country Code
        FSMS.SetFieldValue 6128, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingCountry", "US")
        
        '6129-FXF Billing Company Name
        FSMS.SetFieldValue 6129, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingCompany", Alltrim(CS32.GetVar("xFROM1")))
        
        '6130-FXF Billing Address Line 1
        FSMS.SetFieldValue 6130, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingAddress1", Alltrim(CS32.GetVar("xFROM2")))
        
        XC1 = Alltrim(CS32.GetVar("xfrom3"))
        
        '6134-FXF Billing Postal Code
        FSMS.SetFieldValue 6134, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingZip", Alltrim(Right(XC1, 5)))
        
        XC1 = Alltrim(Left(XC1, Len(XC1) - 5))
        
        '6132-FXF Billing City
        FSMS.SetFieldValue 6132, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingCity", GetCity(XC1))
         
        '6133-FXF Billing State/Province
        FSMS.SetFieldValue 6133, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingState", GetState(XC1))
        
        '6135-FXF Billing Telephone
        FSMS.SetFieldValue 6135, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingPhone", Alltrim(CS32.GetVar("xfrom4")))
        
        '6137-FXF Billing E-mail ID
        FSMS.SetFieldValue 6137, IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BillingEmail", "")
        
        '6139-FXF Account Number
        FSMS.SetFieldValue 6139, IniRead(fxfDir & "FDXF.ini", "Account" & csAcctNo, "FreightAccount", "342976573")
        
        '6142-Total Handling Units
        FSMS.SetFieldValue 6142, kdvBlData("hnd_qty")
        
        '6155-Guaranteed Services Upgrade
        
        '6167-BOL Format
        FSMS.SetFieldValue 6167, "1"     '1=Uniform, 2=VICS
    
        '6211-LTL Declared Value Units
        'FSMS.SetFieldValue 6211,Alltrim(DevRead(CS32,"xunit"))
        
        
        '6219-Article Type
        'FSMS.SetFieldValue 6211,"N"
        
        XN1 = 1
        Do While Not kdvBlData.EOF
            '1670-Fractional Package Weight
            FSMS.SetSubFieldValue 1670, CLng(XN1), CLng(Val(kdvBlData("WEIGHT")) * 100)
            
            '2931-Number of Pieces
            FSMS.SetSubFieldValue 2931, CLng(XN1), CInt(kdvBlData("pkg_qty"))
            
            '6105-NMFC Class
            FSMS.SetSubFieldValue 6105, CLng(XN1), Trim(Str(CDbl(kdvBlData("class")), 6, 1))
            
            '6166-LTL Freight Package Type
            XC1 = kdvBlData("HND_TYPE")
            If XC1 = "SKID" Then
                XC2 = "2"
            Else
                XC2 = "1" 'Pallet
            End If
            FSMS.SetSubFieldValue 6166, CLng(XN1), XC2
                
            '6246-Line Item Description (could be multiple)
            FSMS.SetSubFieldValue 6246, CLng(XN1), kdvBlData("itemdesc")
        
            kdvBlData.MoveNext
            XN1 = XN1 + 1
        Loop
        
        '99
        FSMS.SetFieldValue 99, """"
        
        FSMS.EndTrans
    
        
        Set kdvBlData = Nothing
        
        If FSMS.GetFieldValue(3) <> "ERROR" Then
           CS32.SetError "FSMS Error: " & FSMS.GetFieldValue(3)
           Exit Sub
        End If
    
        Dim sBLTrackNo As String
        
        sBLTrackNo = FSMS.GetFieldValue(29)
        CS32.SetVar "xTRACK_NO", sBLTrackNo
        CS32.SetVar "xSHP_CHG", CDec(FSMS.GetFieldValue(34)) / 100
        CS32.SetVar "xTOT_CHG", CDec(FSMS.GetFieldValue(37)) / 100
         
        fErase fxfDir & "Labels\" & sBLTrackNo & ".txt"
        fMove "\\ttv-clippershipper\fedex_labelbuffer\" & sBLTrackNo, fxfDir & "Labels\" & sBLTrackNo & ".txt"
        'XC1 = Common.SaveTextToFile(FSMS.GetFieldValue(188), sBLTrackNo, "txt", fxfDir & "Labels", Overwrite) & ".txt"
        
        FedExFreight.FXF_PrintLabel sBLTrackNo
        
        Dim sBlReportSrcPath As String, sBlReportSavePath As String
        sBlReportSrcPath = IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "FSMSReportPath", IniRead(fxfDir & "FDXF.ini", "Settings", "FSMSReportPath", "\\" & fxfFsmsIP & "\FedEx_Reports"))
        sBlReportSavePath = IniRead(fxfDir & "FDXF.ini", "Account" + csAcctNo, "BOLReportSavePath", IniRead(fxfDir & "FDXF.ini", "Settings", "BOLReportSavePath", fxfDir & "BOL\"))
        
        If Right(sBlReportSrcPath, 1) <> "\" Then
            sBlReportSrcPath = sBlReportSrcPath & "\"
        End If
        If Right(sBlReportSavePath, 1) <> "\" Then
            sBlReportSavePath = sBlReportSavePath & "\"
        End If
        
        XC1 = "Uniform_BOL_" & sBLTrackNo & ".PDF"
        kiDebug "BL Report: " & sBlReportSrcPath & XC1, ProjectDir & "Debug.log", "FXF_Process"
        
        XN1 = Timer
        Do While Not fExist(sBlReportSrcPath & XC1) And XN1 + 5 < Timer
            DoEvents
        Loop
        
        fMove sBlReportSrcPath & XC1, sBlReportSavePath & XC1
        
        XC2 = ""
        If Not Common.GetCommonSetting(XC2, "PdfReader") Then
            XC2 = IniRead(fxfDir & "FDXF.ini", "Settings:" & ComputerName, "PdfReader", IniRead(fxfDir & "FDXF.ini", "Settings", "PdfReader", ""))
        End If
        
        kiDebug "PDFReader[" & ComputerName & "]: " & XC2, ProjectDir & "Debug.log", "FXF_Process"
        If fExist(sBlReportSavePath & XC1) And fExist(XC2) Then
            WinExec XC2 & " """ & sBlReportSavePath & XC1 & """"
        Else
            XC3 = ""
            If Not fExist(sBlReportSavePath & XC1) Then
                XC3 = XC3 & "BOL report not found!!" & vbLf & vbLf
            End If
            If Not fExist(XC2) Then
                XC3 = XC3 & "PDF reader not configured!!"
            End If
            MsgBox XC3, vbCritical + vbApplicationModal, "FedEx Freight"
        End If
        
        FSMS.Terminate
    End If
    
GoTo OVERERROR
    
ERRORHANDLER:
    
    XC1 = "ERROR: " & Alltrim(CS32.GetVar("xpkgid")) & ":" & Err.Number & ":" & Err.Description
    kiDebug XC1, ProjectDir & "Debug.log", "FXF_Process()"
    MsgBox XC1
    
OVERERROR:

End Sub

Public Function FXF_PrintLabel(Optional ByVal sTrackNo As String = "") As Boolean
    FXF_PrintLabel = False
    
    Dim fxfService As String
    fxfService = FXF_GetService(CS32.Intcode)
    If KiEmpty(fxfService) Then
        Exit Function
    End If
    
    Dim sPrinterName As String
    If Not Common.GetCommonSetting(sPrinterName, "LabelPrinter") Then
        sPrinterName = IniRead(fxfDir & "FDXF.ini", "Settings:" & ComputerName, "LabelPrinter", IniRead(fxfDir & "FDXF.ini", "Settings", "LabelPrinter", ""))
    End If
    
    If KiEmpty(sPrinterName) Then
        MsgBox "FedEx Freight label printer not defined!", vbCritical
    Else
        If KiEmpty(sTrackNo) Then
            sTrackNo = Trim(CS32.GetVar("xTRACK_NO"))
        End If
        
        XC1 = fxfDir & "Labels\" & sTrackNo & ".txt"
        If fExist(XC1) Then
            kiDebug "FedEx Freight label=" & XC1, ProjectDir() & "Debug.log", "FXF_PrintLabel"

            XC2 = ""
            XN2 = 0
            XC3 = "LabelsPerHndQty"
            If Not Common.GetCommonSetting(XC2, XC3) Then
                XC2 = IniRead(NetDir & "common.ini", "Settings:" & ComputerName, XC3, IniRead(NetDir & "common.ini", "Global Settings", XC3, "2"))
            End If
            If Val(XC2) > 0 Then
                XN2 = CInt(XC2)
                XN3 = CInt(CS32.GetVar("xxQTY"))
                If XN3 > 0 Then
                    XN2 = XN2 * XN3
                End If
            End If
            
            kiDebug "Send FedEx Freight label to " & sPrinterName & "(copies=" & CInt(XN2) & ")", ProjectDir() & "Debug.log", "FXF_PrintLabel"
            Common.SendFileToPrinter sPrinterName, XC1, XN2
            
            FXF_PrintLabel = True
        Else
            MsgBox "Label file missing: " & vbLf & """" & XC1 & """", vbCritical
        End If
    End If
End Function
