Attribute VB_Name = "LSX"
Public ini As String
Public ProjDir As String
Public loggingLevel As Integer
Public loggingDir As String
Public loggingCsFields As String
Public showDebug As Boolean

Public sToCtryIso As String


Sub Init()
    ProjDir = RunDir & Project.ProjectName
    If Not fExist(RunDir & Project.ProjectName, vbDirectory, vbDirectory) Then
        MkDir RunDir & Project.ProjectName
    End If
    
    ProjDir = ProjDir & "\"
    
    ini = ProjDir & "config.ini"
    
    showDebug = (IniRead(ini, "Settings", "ShowDebug", "N") = "Y")
    
    Log_Init
End Sub


Public Sub Log_Init()
    loggingLevel = Int(IniReadInit(ini, "Logging", "Level", "5"))
    loggingDir = IniReadInit(ini, "Logging", "Path", ProjDir & "Logs")
    
    If Not fExist(loggingDir, vbDirectory, vbDirectory) Then
        MkDir loggingDir
    End If
    loggingDir = loggingDir & "\"
    
    loggingCsFields = IniReadInit(ProjectDir & "config.ini", "Logging", "CsFieldList", "PKGID;ORD_CNT;EXP_CNT;TRACK_NO;TRACK_MOM;SHP_CHG;TOT_CHG;RECORDID;DATE;TIME;USERNAME;")
    
    Log_Cleanup
End Sub

Public Sub log_Write(strLogText, Optional logLevel As Integer = 1)
    If (loggingLevel >= logLevel) Then
        LogFile.FileName = loggingDir & Project.ProjectName & "_" & Format(Date, "yyyy-mm-dd") & ".log"
        LogFile.Mode = [For Append]
        LogFile.Start
        
        LogFile.AppendLine Format(Date, "mm/dd/yyyy") & " " & Format(Time, "hh:mm:ss") & "." & Format((Timer * 1000) Mod 1000, "000") & " " & strLogText
        LogFile.Terminate
    End If
End Sub

Public Sub Log_Cleanup()
    XN1 = Int(IniReadInit(ini, "Logging", "KeepDays", "90"))
    XC1 = fFirst(loggingDir & "*.log")
    Do While Len(XC1) <> 0
        If ((Date - fDate(loggingDir & XC1)) > XN1) Then
            fErase (loggingDir & XC1)
            log_Write "Log_Cleanup: Deleted " & XC1, 3
        End If
        XC1 = fNext()
    Loop
End Sub

Public Function IniReadInit(strPathname As String, strSection As String, strEntry As String, strDefault As String) As String
    IniReadInit = IniRead(strPathname, strSection, strEntry, "")
    If (IniReadInit = "") Then
        IniWrite strPathname, strSection, strEntry, strDefault
        IniReadInit = strDefault
    End If
End Function

Public Sub DMsgBox(sPrompt As String, Optional style As VbMsgBoxStyle = vbOKOnly, Optional sTitle As String = "")
    If showDebug Then
        MsgBox sPrompt, style, sTitle
    End If
End Sub

Public Function GetCountry(ByVal sCountry As String, ByVal sIntcode As String) As String
    GetCountry = sCountry
    
    Dim sCarrier As String
    Dim sIsoTable As String
    Dim sCondition As String
    Dim sCtryNameField As String
    
    Dim kdvCtryName As KiDataView
    
    If Len(sCountry) = 2 Then
        sCountryIso = sCountry
    End If
    
    If sCountryIso = "US" Then
        GetCountry = "UNITED STATES"
    ElseIf Len(sCountryIso) = 2 Then
        Select Case sIntcode
        Case "R00" To "RZZ", "F00" To "FZZ"
            sCarrier = "FDX"
            sIsoTable = CS32.ShipDir & "FDX\FDX_ISO.FIL"
            sCondition = "ISO_CODE='" & sCountryIso & "'"
            sCtryNameField = "COUNTRY"
        Case "D00" To "DZZ"
            sCarrier = "DHL"
            sIsoTable = CS32.ShipDir & "DHL\DHL_CTYF.FIL"
            sCondition = "CTRYCODE='" & sCountryIso & "'"
            sCtryNameField = "CTRYNAME"
        Case "P00" To "PZZ"
            sCarrier = "USPS"
            sIsoTable = CS32.ShipDir & "POS\POS_IZON.FIL"
            sCondition = "ISO_CODE='" & sCountryIso & "'"
            sCtryNameField = "COUNTRY"
        Case "XE0" To "XEZ", "ZE0" To "ZEZ"
            sCarrier = "USPS"
            sIsoTable = ""
            sCondition = ""
            sCtryNameField = ""
        Case Else
            sCarrier = "UPS"
            sIsoTable = CS32.ShipDir & "UPS\UPS_ISO.FIL"
            sCondition = "ISO_CODE='" & sCountryIso & "'"
            sCtryNameField = "COUNTRY"
        End Select
        
        If fExist(sIsoTable) Then
            Set kdvCtryName = DbfSelect(sIsoTable, sCondition, Array(sCtryNameField))
            If kdvCtryName.RowCount > 0 Then
                GetCountry = kdvCtryName(sCtryNameField)
            End If
            
            Set kdvCtryName = Nothing
        End If
    End If
End Function

Public Sub CleanAddress()
    Dim sFields As String
    sFields = "SHIPTO1;SHIPTO2;SHIPTO3;SHIPTO4;SHIPTO5;SHIPTO6;SHIPTO7;ZIP;COUNTRY;PHONE"
    
    Dim i As Integer
    i = 1
    
    Do While True
        Dim sField As String
        sField = SubToken(sFields, (i), ";")
        If KiEmpty(sField) Then
            Exit Do
        End If
        
        Dim sData As String
        sData = Alltrim(CS32.GetVar("x" & sField))
        
        If Not KiEmpty(sData) Then
            sData = StrTran(sData, """", " ")
            sData = StrTran(sData, "^", " ")
            sData = StrTran(sData, "'", " ")
            sData = StrTran(sData, "&", " AND ")
            
            Do While InStr(sData, "  ") > 0
                sData = StrTran(sData, "  ", " ")
            Loop
            
            CS32.SetVar "x" & sField, sData
        End If
        i = i + 1
    Loop
End Sub
