VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} formMultiPkg 
   Caption         =   "Shipment Package Information"
   ClientHeight    =   4740
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   9330
   OleObjectBlob   =   "formMultiPkg.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "formMultiPkg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim kdvPkgInfo As KiDataView, kdvDims As KiDataView, kdvRateShops As KiDataView

Private Sub SetInitialValues()
    txtQty.Text = "1"
    txtWeight.Text = ""
    cboxDims.Text = " "
    txtLen.Text = ""
    txtWid.Text = ""
    txtHgt.Text = ""
    
    cboxClass.Text = IniRead(NetDir & "BL\BL.ini", "Defaults", "Class", "70")
    txtDesc = IniRead(NetDir & "BL\BL.ini", "Defaults", "ItemDesc", "")
    
    txtQty.SetFocus
    txtQty.SelStart = 0
    txtQty.SelLength = 1
End Sub

Private Sub Populate_ListPkgInfo()
    Me.listPkgs.Clear
    
    Set kdvPkgInfo = DbfSelect(ProjectDir & "PKG_INFO.DBF", "PKGID='" & CS32.GetVar("xPKGID") & "'")
    Do While Not kdvPkgInfo.EOF
        Dim sNewPkgInfo As String
        
        sNewPkgInfo = Trim(Str(Val(kdvPkgInfo("PKG_QTY")), -1, 0)) & vbTab & _
            "@ " & Trim(kdvPkgInfo("ACT_WGT")) & " LB" & vbTab
        If Not KiEmpty(Trim(kdvPkgInfo("DIMENSIONS"))) Then
            sNewPkgInfo = sNewPkgInfo & Trim(kdvPkgInfo("DIMENSIONS"))
        End If
        sNewPkgInfo = sNewPkgInfo & vbTab & Trim(kdvPkgInfo("CLASS"))
        sNewPkgInfo = sNewPkgInfo & vbTab & Trim(kdvPkgInfo("DESC"))
        
        listPkgs.AddItem sNewPkgInfo
        
        kdvPkgInfo.MoveNext
    Loop
    Set kdvPkgInfo = Nothing
End Sub


Private Function ListPkgInfo_Pkg_Count() As Integer
    Dim iTotalPkgs As Integer
    
    iTotalPkgs = 0
    Me.lblPkgTotal = ""
    
    For i = 0 To listPkgs.ListCount - 1
        iTotalPkgs = iTotalPkgs + Int(SubToken(listPkgs.List(i), 1, vbTab))
    Next

    If iTotalPkgs > 0 Then
        Me.lblPkgTotal.Caption = iTotalPkgs & " pkg(s)."
    End If
    ListPkgInfo_Pkg_Count = iTotalPkgs
End Function

Private Sub btnAdd_Click()
    If (Val(txtQty.Text) < 1) Then
        MsgBox "# of packages must be greater than 0!", vbCritical, ""
        txtQty.SetFocus
    
        Exit Sub
    End If
    
    If (Val(txtWeight.Text) <= 0) Then
        MsgBox "Weight must be greater than 0!", vbCritical, ""
        txtWeight.SetFocus
        
        Exit Sub
    End If
    
    If (Val(txtWeight.Text) > 150) Then
        XN1 = MsgBox("Weight is greater than 150! Are you sure?", vbExclamation + vbYesNo + vbDefaultButton2, "")
        If XN1 = 7 Then
            txtWeight.SetFocus
            Exit Sub
        End If
    End If
    
    If Common.GetLength(Val(txtLen.Text), Val(txtWid.Text), Val(txtHgt.Text)) > 108 Then
        XN1 = MsgBox("Length is greater than 108! Are you sure?", vbExclamation + vbYesNo + vbDefaultButton2, "")
        If XN1 = 7 Then
            txtLen.SetFocus
            Exit Sub
        End If
    End If
    If Common.GetLengthPlusGirth(Val(txtLen.Text), Val(txtWid.Text), Val(txtHgt.Text)) > 165 Then
        XN1 = MsgBox("Length+Girth is greater than 165! Are you sure?", vbExclamation + vbYesNo + vbDefaultButton2, "")
        If XN1 = 7 Then
            txtLen.SetFocus
            Exit Sub
        End If
    End If
    
    If (Val(txtLen.Text) <= 0 Or Val(txtWid.Text) <= 0 Or Val(txtHgt.Text) <= 0) Then
        txtLen.Text = ""
        txtWid.Text = ""
        txtHgt.Text = ""
    End If
    
    XC1 = Alltrim(Str(Val(txtQty.Text), -1, 0)) & vbTab & "@ " & txtWeight.Text & " LB" & vbTab
    XC2 = txtQty.Text & "|" & txtWeight.Text
    If (Val(txtLen.Text) * Val(txtWid.Text) * Val(txtHgt.Text)) > 0 Then
        XC1 = XC1 & txtLen.Text & "x" & txtWid.Text & "x" & txtHgt.Text
        XC2 = XC2 & "|" & txtLen.Text & "x" & txtWid.Text & "x" & txtHgt.Text
    End If
    XC1 = XC1 & vbTab & Me.cboxClass.Text & _
        vbTab & Me.txtDesc
    
    listPkgs.AddItem XC1
    
    Set kdvPkgInfo = DbfVarDeclare(ProjectDir & "PKG_INFO.DBF")
    kdvPkgInfo("PKGID") = CS32.GetVar("xPKGID")
    kdvPkgInfo("PKG_QTY") = txtQty.Text
    kdvPkgInfo("ACT_WGT") = txtWeight.Text
    kdvPkgInfo("DIMENSIONS") = SubToken(XC1, 3, vbTab)
    kdvPkgInfo("CLASS") = cboxClass.Text
    kdvPkgInfo("DESC") = txtDesc.Text
    DbfAddNew ProjectDir & "PKG_INFO.DBF", kdvPkgInfo
    Set kdvPkgInfo = Nothing
    
    ListPkgInfo_Pkg_Count
    SetInitialValues
End Sub

Private Sub BtnCancel_Click()
    Dim boolExit As Boolean
    boolExit = True
    
    If (listPkgs.ListCount > 0) Then
        boolExit = False
        If MsgBox("Delete all package information?", vbQuestion) = vbOK Then
            DbfZap ProjectDir & "PKG_INFO.DBF"
            boolExit = True
        End If
    End If
    
    If boolExit Then
        Unload Me
    End If
End Sub

Private Sub btnDelete_Click()
    Me.listPkgs.RemoveItem Me.listPkgs.ListIndex
    
    DbfDelete ProjectDir & "PKG_INFO.DBF", Me.listPkgs.ListIndex + 1, True, 1
    DbfCleanup ProjectDir & "PKG_INFO.DBF"
    
    ListPkgInfo_Pkg_Count
End Sub

Private Sub btnEdit_Click()
    Dim sPkgInfo As String
    Dim sPkgDims As String
    
    SetInitialValues
    
    sPkgInfo = listPkgs.List(listPkgs.ListIndex)
    
    Me.txtQty = Alltrim(SubToken(sPkgInfo, 1, vbTab))
    Me.txtWeight = Alltrim(SubToken(SubToken(sPkgInfo, 2, "@"), 1, "LB"))
    
    sPkgDims = Alltrim(SubToken(sPkgInfo, 3, vbTab))
    If Not KiEmpty(sPkgDims) Then
        Me.txtLen = SubToken(sPkgDims, 1, "x")
        Me.txtWid = SubToken(sPkgDims, 2, "x")
        Me.txtHgt = SubToken(sPkgDims, 3, "x")
    End If
    
    Dim i As Integer
    Dim sClass As String
    sClass = Trim(SubToken(sPkgInfo, 4, vbTab))
    If Not KiEmpty(sClass) Then
        For i = 0 To Me.cboxClass.ListCount - 1
            If Me.cboxClass.List(i) = sClass Then
                Me.cboxClass.Text = sClass
                Exit For
            End If
        Next
    End If
    
    Me.txtDesc.Text = Trim(SubToken(sPkgInfo, 5, vbTab))
    
    Me.listPkgs.RemoveItem Me.listPkgs.ListIndex

    DbfDelete ProjectDir & "PKG_INFO.DBF", Me.listPkgs.ListIndex + 1, True, 1
    DbfCleanup ProjectDir & "PKG_INFO.DBF"
    
    ListPkgInfo_Pkg_Count
End Sub

Private Sub btnOk_Click()
    If (listPkgs.ListCount < 1) Then
        MsgBox "At least 1 package required!", vbInformation
        txtQty.SetFocus
        Exit Sub
    End If
    
    Dim sPkgInfo As String, sPkgDims As String
    sPkgInfo = listPkgs.List(0)
    sPkgDims = Alltrim(SubToken(sPkgInfo, 3, vbTab))
    
    CS32.SetVar "xACT_WGT", Val(SubToken(SubToken(sPkgInfo, 2, "@"), 1, "LB"))
    CS32.SetVar "xDIM_LENGTH", SubToken(sPkgDims, 1, "x")
    CS32.SetVar "xDIM_WIDTH", SubToken(sPkgDims, 2, "x")
    CS32.SetVar "xDIM_HEIGHT", SubToken(sPkgDims, 3, "x")
    
    CS32.SetVar "xCLASS", SubToken(sPkgInfo, 4, vbTab)
    CS32.SetVar "xDESC", SubToken(sPkgInfo, 5, vbTab)
    
    Dim i As Integer, iPkgCnt As Integer
    iPkgCnt = 0
    For i = 0 To listPkgs.ListCount - 1
        iPkgCnt = iPkgCnt + CInt(SubToken(listPkgs.List(i), 1, vbTab))
    Next
    CS32.SetVar "xEXP_CNT", iPkgCnt
    
    Unload Me
    CS32.DisableRecord False
End Sub

Private Sub btnRate_Click()
    If (listPkgs.ListCount < 1) Then
        MsgBox "At least 1 package required!", vbInformation
        txtQty.SetFocus
        Exit Sub
    End If
    
    If KiEmpty(Alltrim(cboxRateShops.Text)) Then
        MsgBox "Please select a service!", vbInformation
        cboxRateShops.SetFocus
        Exit Sub
    End If
        
    XC1 = ""
    If KiEmpty(Trim(CS32.GetVar("xSHIPTO1") & CS32.GetVar("xSHIPTO3"))) Then
        XC1 = XC1 & "Ship-to company or attention required!" & vbLf
    End If
    If KiEmpty(Trim(CS32.GetVar("xSHIPTO4"))) Then
        XC1 = XC1 & "Ship-to address required!" & vbLf
    End If
    If KiEmpty(Trim(CS32.GetVar("xSHIPTO7"))) Then
        XC1 = XC1 & "Ship-to city/state required!" & vbLf
    End If
    If KiEmpty(Trim(CS32.GetVar("xZIP"))) Then
        XC1 = XC1 & "Ship-to postal code required!" & vbLf
    End If
    If Not KiEmpty(XC1) Then
        MsgBox XC1, vbCritical + vbApplicationModal
        Exit Sub
    End If
    
    Dim sCarrOrig As String
    Dim kdvRateShop As KiDataView
    Dim kdvRsResult As KiDataView
    
    sCarrOrig = Alltrim(CS32.GetVar("xCARRIER"))
    Me.cboxRateShops.Text = Alltrim(Me.cboxRateShops.Text)
    
    Set kdvRateShop = DbfLookup(CS32.ShipDir & "CS_CARR.FIL", PadR(Trim(cboxRateShops.Text), 10, " "))
    
    DbfZap ProjectDir & "RS_DETAIL.DBF"
    DbfZap ProjectDir & "RS_RESULT.DBF"
    
    Dim sUPSGfpCarr As String, sFDXMWTCarr As String
    sUPSGfpCarr = ""
    sFDXMWTCarr = ""
    
    For iShopCarrier = 30 To 1 Step -1
        Dim sCarrier As String
        
        sCarrier = Alltrim(kdvRateShop("SHOP" & Alltrim(Str(iShopCarrier, 2, 0))))
        If Not KiEmpty(sCarrier) Then
            Rate_Shipment sCarrier, iShopCarrier
        
            Dim kdvTmpCar1 As KiDataView
            Set kdvTmpCar1 = DbfLookup(ProjectDir & "CS_CARR.DBF", PadR(sCarrier, 10, " "), True)
            If Not kdvTmpCar1.EOF Then
                For j = 1 To 30
                    If Not KiEmpty(Trim(kdvTmpCar1("SHOP" & Trim(CStr(j))))) Then
                        Dim kdvTmpCar2 As KiDataView
                        Set kdvTmpCar2 = DbfLookup(ProjectDir & "CS_CARR.DBF", PadR(kdvTmpCar1("SHOP" & Trim(CStr(j))), 10))
                        If Not kdvTmpCar2.EOF Then
                            If kdvTmpCar2("INTCODE") = "U76" Then
                                sUPSGfpCarr = Trim(kdvTmpCar1("CARRIER"))
                            ElseIf kdvTmpCar2("INTCODE") = "R17" Then
                                sFDXMWTCarr = Trim(kdvTmpCar1("CARRIER")) & Chr(3) & Trim(kdvTmpCar1("SHOP" & Trim(CStr(j))))
                            End If
                        End If
                        Set kdvTmpCar2 = Nothing
                    End If
                Next
                Set kdvTmpCar1 = Nothing
            End If
        End If
    Next
    Set kdvRateShop = Nothing
    
    If Not KiEmpty(sUPSGfpCarr) Then
        Dim upsRate As UpsAPI.UpsRateResult
        CS32.Intcode = "U76"
        upsRate = UpsAPI.GetRate(False)
        CS32.Intcode = CS32.GetVar("xINTCODE")
        If upsRate.Success Then
            Set kdvRsResult = DbfSelect(ProjectDir & "RS_RESULT.DBF", "CARRIER='" & PadR(sUPSGfpCarr, 10) & "'", , 1)
            'If XN1 < CDbl(kdvRsResult("OTOT_CHG")) Then
                kdvRsResult("OSHP_CHG") = upsRate.Base
                kdvRsResult("OTOT_CHG") = upsRate.Total
                'kdvRsResult("CARDESC") = Trim(kdvRsResult("CARDESC")) & " [Grd Frt Price]"
            'End If
            kdvRsResult.Update
            Set kdvRsResult = Nothing
        End If
    End If
    
    If Not KiEmpty(sFDXMWTCarr) Then
        If FSMS.GetRate_MWT Then
            Set kdvRsResult = DbfSelect(ProjectDir & "RS_RESULT.DBF", "CARRIER='" & PadR(SubToken(sFDXMWTCarr, 2, Chr(3)), 10) & "'", , 1)
            
            XN1 = Val(CS32.GetVar("xSHP_CHG"))
            XN2 = Val(CS32.GetVar("xTOT_CHG"))
            
            If kdvRsResult.RowCount = 0 Then
                Set kdvRsResult = Nothing
                
                Set kdvRsResult = DbfVarDeclare(ProjectDir & "RS_RESULT.DBF")
                
                kdvRsResult("CARRIER") = Trim(SubToken(sFDXMWTCarr, 1, Chr(3)))
                kdvRsResult("ORIG_CARR") = Trim(SubToken(sFDXMWTCarr, 2, Chr(3)))
                kdvRsResult("CARDESC") = "FedEx Ground Multiweight"
                
                kdvRsResult("PKG_QTY") = iPkgQty
                kdvRsResult("OSHP_WGT") = Val(CS32.GetVar("xSHP_WGT")) * iPkgQty
                
                kdvRsResult("OSHP_CHG") = XN1
                kdvRsResult("OTOT_CHG") = XN2
                
                DbfAddNew ProjectDir & "RS_RESULT.DBF", kdvRsResult
            Else
                kdvRsResult("OSHP_CHG") = XN1
                kdvRsResult("OTOT_CHG") = XN2
                kdvRsResult.Update
            End If
            
            Set kdvRsResult = Nothing
        End If
    End If
    
    CS32.SetVar "xCARRIER", sCarrOrig
    
    'DbfEdit ProjectDir & "RS_DETAIL.DBF"
    'DbfEdit ProjectDir & "RS_RESULT.DBF"
    Dim x As New formRateShopResult
    x.Show vbModal
    
    If Not KiEmpty(x.Result) Then
        Rate_Shipment x.Result
        
        CS32.SetVar "xCARRIER", x.Result

        btnOk_Click
        'Unload Me
    End If
    
    Unload x
End Sub

Sub Rate_Shipment(ByVal sCarrier As String, Optional ByVal iShopNo As Integer = 1)
    
    Dim sCarrierTmp As String
    sCarrierTmp = sCarrier
    For i = 0 To listPkgs.ListCount - 1
        Dim sPkgInfo As String
        Dim iPkgQty As Integer
        Dim sPkgDims As String
        Dim dblPkgWgt As Double
        Dim sResFlag As String
        
        sPkgInfo = listPkgs.List(i)
        
        iPkgQty = Int(SubToken(sPkgInfo, 1, vbTab))
        dblPkgWgt = Val(SubToken(SubToken(sPkgInfo, 2, "@"), 1, "LB"))
        sPkgDims = Alltrim(SubToken(sPkgInfo, 3, vbTab))
        
        If kdvShipment Is Nothing Then
            sResFlag = CS32.GetVar("xRES_FLAG")
        Else
            sResFlag = kdvShipment("Residential_Flag")
        End If
        
        If sResFlag = "Y" Then
            
            Dim kdvCarrSrc As KiDataView, kdvCarrNew As KiDataView
            
            sCarrierTmp = iShopNo
            If iShopNo > 9 Then
                sCarrierTmp = Chr(iShopNo + 55)
            End If
                
            sCarrierTmp = "_" & CS32.csUsername & sCarrierTmp
                
            CreateDynamicCarrierCode sCarrierTmp
            
            Set kdvCarrSrc = DbfSelect(CS32.ShipDir & "CS_CARR.FIL", "TRIM(CARRIER)='" & Trim(sCarrier) & "'", , 1)
            Set kdvCarrNew = DbfSelect(CS32.ShipDir & "CS_CARR.FIL", "TRIM(CARRIER)='" & Trim(sCarrierTmp) & "'", , 1)
            
            Dim iField As Integer
            Dim sTmpIntcode As String
            ssrcintcode = kdvCarrSrc("INTCODE")
            For iField = 0 To kdvCarrSrc.Fields.Count - 1
                Select Case kdvCarrSrc.Fields(iField).Name
                    Case "CARRIER"
                    Case "USE_RES"
                        If Left(ssrcintcode, 1) = "R" Then
                            kdvCarrNew.Fields(iField) = "Q"
                        Else
                            kdvCarrNew.Fields(iField) = "Y"
                        End If
                    Case Else
                        kdvCarrNew.Fields(iField) = kdvCarrSrc.Fields(iField)
                        'If kdvCarrSrc.Fields(iField).Name = "INTCODE" Then
                        '    MsgBox kdvCarrNew.Fields(iField)
                        'End If
                End Select
            Next
            kdvCarrNew.Update
            
            Set kdvCarrSrc = Nothing
            Set kdvCarrNew = Nothing
        End If
        
        CS32.SetVar "xCARRIER", sCarrierTmp
        CS32.SetVar "xACT_WGT", dblPkgWgt
        
        XC1 = Alltrim(SubToken(XC1, 2, vbTab))
        
        If KiEmpty(sPkgDims) Then
            CS32.SetVar "xDIM_LENGTH", "0"
            CS32.SetVar "xDIM_WIDTH", "0"
            CS32.SetVar "xDIM_HEIGHT", "0"
        Else
            CS32.SetVar "xDIM_LENGTH", SubToken(sPkgDims, 1, "x")
            CS32.SetVar "xDIM_WIDTH", SubToken(sPkgDims, 2, "x")
            CS32.SetVar "xDIM_HEIGHT", SubToken(sPkgDims, 3, "x")
        End If
        
        CS32.SetVar "xCLASS", SubToken(sPkgInfo, 4, vbTab)
        CS32.SetVar "xDESC", SubToken(sPkgInfo, 5, vbTab)
    
        CS32.SetVar "xUSE_AH", "N"
        
        CS32.RateTrans
        XN1 = Val(CS32.GetVar("xSHP_CHG"))
        If XN1 <= 0 Then
            If (i > 0) Then
                DbfDelete ProjectDir & "RATESHOP.DBF", "CARRIER='" & PadR(sCarrier, 10) & "'", True, 0
            End If
            Exit For
        Else
            Dim kdvRsDetail As KiDataView, kdvRsResult As KiDataView

            Set kdvRsDetail = DbfVarDeclare(ProjectDir & "RS_DETAIL.DBF")
            
            kdvRsDetail("CARRIER") = sCarrier
            kdvRsDetail("PKGTYPENO") = i
            
            kdvRsDetail("PKG_QTY") = iPkgQty
            kdvRsDetail("DIMENSIONS") = sPkgDims
            kdvRsDetail("SHP_WGT") = Val(CS32.GetVar("xSHP_WGT")) * iPkgQty
            kdvRsDetail("SHP_CHG") = Val(CS32.GetVar("xSHP_CHG")) * iPkgQty
            kdvRsDetail("TOT_CHG") = Val(CS32.GetVar("xTOT_CHG")) * iPkgQty
            
            DbfAddNew ProjectDir & "RS_DETAIL.DBF", kdvRsDetail
            Set kdvRsDetail = Nothing
            
            XN1 = Val(CS32.GetVar("xSHP_WGT"))
            XN2 = Val(CS32.GetVar("xSHP_CHG"))
            XN3 = Val(CS32.GetVar("xTOT_CHG"))
            
            If (i = 0) Then
                Set kdvRsResult = DbfVarDeclare(ProjectDir & "RS_RESULT.DBF")
                
                kdvRsResult("CARRIER") = sCarrier
                kdvRsResult("CARDESC") = CS32.GetVar("xCARDESC")
                
                kdvRsResult("PKG_QTY") = iPkgQty
                kdvRsResult("OSHP_WGT") = XN1 * iPkgQty
                kdvRsResult("OSHP_CHG") = XN2 * iPkgQty
                kdvRsResult("OTOT_CHG") = XN3 * iPkgQty
                
                DbfAddNew ProjectDir & "RS_RESULT.DBF", kdvRsResult
                Set kdvRsResult = Nothing
            Else
                Set kdvRsResult = DbfSelect(ProjectDir & "RS_RESULT.DBF", "CARRIER='" & PadR(sCarrier, 10) & "'", , 1)
                
                kdvRsResult("PKG_QTY") = kdvRsResult("PKG_QTY") + iPkgQty
                kdvRsResult("OSHP_WGT") = kdvRsResult("OSHP_WGT") + XN1 * iPkgQty
                kdvRsResult("OSHP_CHG") = kdvRsResult("OSHP_CHG") + XN2 * iPkgQty
                kdvRsResult("OTOT_CHG") = kdvRsResult("OTOT_CHG") + XN3 * iPkgQty
                
                kdvRsResult.Update
                Set kdvRsResult = Nothing
            End If
            
        End If
    Next
End Sub

Private Sub btnWeigh_Click()
    Dim dblWeight As Double
    dblWeight = CDbl(CS32.GetVar("xACT_WGT"))
    CS32.SetVar "xACT_WGT", 0
    
    If CS32.ReadScale(1) Then
        Me.txtWeight = Trim(CS32.GetVar("xACT_WGT"))
        Me.cboxDims.SetFocus
    Else
        MsgBox "Error reading scale!", vbCritical
    End If
    CS32.SetVar "xACT_WGT", dblWeight
End Sub

Private Sub cboxDims_Change()
    If (cboxDims.Text = " ") Then
        txtLen.Enabled = True
        txtWid.Enabled = True
        txtHgt.Enabled = True
    Else
        Dim sDimsTxt As String
        
        sDimsTxt = cboxDims.List(cboxDims.ListIndex, 1)
        
        txtLen.Text = Alltrim(SubToken(sDimsTxt, 1, "x"))
        txtWid.Text = Alltrim(SubToken(sDimsTxt, 2, "x"))
        txtHgt.Text = Alltrim(SubToken(sDimsTxt, 3, "x"))
        
        txtLen.Enabled = False
        txtWid.Enabled = False
        txtHgt.Enabled = False
    End If
End Sub


Private Sub CommandButton1_Click()

End Sub

Private Sub listPkgs_Click()
    If Len(listPkgs.Text) > 0 Then
        btnDelete.Enabled = True
        btnEdit.Enabled = True
    End If
End Sub

Private Sub UserForm_Initialize()
    CS32.DisableRecord True
    
    If KiEmpty(CS32.csUsername) Then
        CS32.csUsername = Trim(CS32.GetVar("xUSERNAME"))
    End If
    
    'Delete any temp carrier codes created in previous rate shops.
    DbfZap CS32.ShipDir & "CS_CARR.FIL", "LEFT(CARRIER, " & (Len(CS32.csUsername) + 1) & ")='~" & CS32.csUsername & "'"
    DbfZap CS32.ShipDir & "CS_CARR.FIL", "LEFT(CARRIER, " & (Len(CS32.csUsername) + 1) & ")='_" & CS32.csUsername & "'"
    
    DbfToDbf CS32.ShipDir & "CS_CARR.FIL", ProjectDir & "CS_CARR.DBF"
    
    Dim kdvDims As KiDataView
    Dim sCarrier As String
    
    DbfIndex ProjectDir & "PKG_INFO.DBF", "RECNO()"
    DbfIndex ProjectDir & "RS_DETAIL.DBF", "CARRIER + STR(PKGTYPENO, 3)"
    DbfIndex ProjectDir & "RS_RESULT.DBF", "CARRIER"
    
    DbfZap ProjectDir & "PKG_INFO.DBF", "PKGID<>'" & PadR(CS32.GetVar("xPKGID"), 20) & "'"
    
    txtPkgid.Text = Alltrim(CS32.GetVar("xPKGID"))
    
    cboxDims.AddItem " "
    cboxDims.Text = " "
    
    'Load dims from dims table into combo box.
    Set kdvDims = DbfSelect(CS32.ShipDir & "CS_DIM.FIL")
    Do While Not kdvDims.EOF
        cboxDims.AddItem Alltrim(kdvDims("DESCRIPT"))
        cboxDims.List(cboxDims.ListCount - 1, 1) = Alltrim(kdvDims("LENGTH")) & "x" & _
            Alltrim(kdvDims("WIDTH")) & "x" & _
            Alltrim(kdvDims("HEIGHT"))
        
        kdvDims.MoveNext
    Loop
    Set kdvDims = Nothing
    
    Dim sClassList() As String
    sClassList = Split(IniRead(NetDir & "BL\BL.ini", "Defaults", "ClassesList", "50;55;60;65;70;77.5;85;92.5;100;110;125;150;175;200;250;300;400;500"), ";")
    For i = 0 To UBound(sClassList) - 1
        Me.cboxClass.AddItem sClassList(i)
    Next
    
    sCarrier = Trim(CS32.GetVar("xCARRIER"))
    
    'Load rate shop codes into combo box.
    Set kdvRateShops = DbfSelect(ProjectDir & "CS_CARR.DBF", "LEFT(INTCODE, 1)='Y'")
    Do While Not kdvRateShops.EOF
        cboxRateShops.AddItem Alltrim(kdvRateShops("CARRIER"))
        cboxRateShops.List(cboxRateShops.ListCount - 1, 1) = Alltrim(kdvRateShops("CARDESC"))
        
        If sCarrier = Trim(kdvRateShops("CARRIER")) Then
            cboxRateShops.Text = sCarrier
        End If

        kdvRateShops.MoveNext
    Loop
    Set kdvRateShops = Nothing
    
    If (listPkgs.Text = "") Then
        btnDelete.Enabled = False
        btnEdit.Enabled = False
    End If
    
    Populate_ListPkgInfo
    
    ListPkgInfo_Pkg_Count

    SetInitialValues
    
    If (listPkgs.ListCount = 0) Then
        txtQty.Text = Trim(CS32.GetVar("xEXP_CNT"))
        txtWeight.Text = Trim(CS32.GetVar("xACT_WGT"))
        cboxDims.Text = " "
        txtLen.Text = Trim(CS32.GetVar("xDIM_LENGTH"))
        txtWid.Text = Trim(CS32.GetVar("xDIM_WIDTH"))
        txtHgt.Text = Trim(CS32.GetVar("xDIM_HEIGHT"))
        
        txtQty.SetFocus
        txtQty.SelStart = 0
        txtQty.SelLength = 1
    End If
End Sub

Private Sub CreateDynamicCarrierCode(ByVal sCarrierCode As String)
    Dim kdvCarrier As KiDataView
    Set kdvCarrier = DbfLookup(CS32.ShipDir & "CS_CARR.FIL", "TRIM(CARRIER)='" & Trim(sCarrierCode) & "'", True, "CARRIER", 1)
    If Not kdvCarrier.EOF Then
        Set kdvCarrier = Nothing
        Exit Sub
    End If
    
    Set kdvCarrier = Nothing
    Set kdvCarrier = DbfVarDeclare(CS32.ShipDir & "CS_CARR.FIL")
    kdvCarrier("CARRIER") = sCarrierCode
    DbfAddNew CS32.ShipDir & "CS_CARR.FIL", kdvCarrier
    Set kdvCarrier = Nothing
End Sub

